SystemOrganization addCategory: #'CS520-HomeAutomation'!

RectangleMorph subclass: #DeviceView
	instanceVariableNames: 'device'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!DeviceView class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 22:20'!
createFromDevice: aDevice
	| newDeviceView |
	newDeviceView := DeviceView new.
	newDeviceView setDevice: aDevice.
	^ newDeviceView.! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 22:21'!
setDevice: aDevice 
	device := aDevice.
	self updateViewFromModel.! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 22:18'!
setLabelProperties
	| label |
	label := StringMorph new.
	label contents: device name.
	label color: (Color black orColorUnlike: self color).
	self borderColor: label color.
	self addMorphCentered: label.! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 22:18'!
setViewProperties
	self width: device width.
	self height: device height.
	self color: device color.! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 22:16'!
updateViewFromModel
	self removeAllMorphs.
	self setViewProperties.
	self setLabelProperties.
	"room devices do: [ :each | self addMorphBack: (DeviceView createFromDevice: each) ]."
	! !

RectangleMorph subclass: #RoomView
	instanceVariableNames: 'room'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!RoomView class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:09'!
createFromRoom: aRoom
	| newRoomView |
	newRoomView := RoomView new.
	newRoomView setRoom: aRoom.
	^ newRoomView.! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 19:13'!
installDevices
	| currPosition hGap vGap |
	hGap := 5.
	vGap := 5.
	currPosition := hGap @ vGap.
	room attachedDevices
		do: [ :each | 
			| newDeviceView |
			self width > (currPosition x + each width + hGap)
				ifTrue: [ 
					newDeviceView := DeviceView createFromDevice: each.
					newDeviceView position: currPosition.
					self addMorphFront: newDeviceView.
					currPosition := currPosition + ((newDeviceView width + hGap) @ 0) ] ]! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 22:19'!
setLabelProperties
	| label |
	label := StringMorph new.
	label contents: room name.
	label color: (Color black orColorUnlike: self color).
	self borderColor: label color.
	self addMorphCentered: label! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:22'!
setRoom: aRoom
	room := aRoom.
	self updateViewFromModel! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 22:19'!
setViewProperties
	self width: room width.
	self height: room height.
	self color: room color.! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 18:55'!
updateViewFromModel
	self removeAllMorphs.
	self setViewProperties.
	self setLabelProperties.
	self installDevices.! !

RectangleMorph subclass: #UserView
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!UserView class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 15:15'!
createFromUser: aUser
	| newUserView |
	newUserView := UserView new.
	newUserView setUser: aUser.
	^ newUserView.! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 15:16'!
setLabelProperties
	| label |
	label := StringMorph new.
	label contents: user name.
	label color: (Color blue orColorUnlike: self color).
	self borderColor: label color.
	self addMorphCentered: label! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 15:15'!
setUser: aUser
	user := aUser.
	self updateViewFromModel.! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 15:24'!
setViewProperties
	self width: 35.
	self height: 80.
	self color: user color.! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 15:16'!
updateViewFromModel
	self setViewProperties.
	self setLabelProperties.! !

TestCase subclass: #HomeAutomationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 2/28/2013 19:48'!
setUp! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:16'!
testAttachDeviceToRoom
	| room device |
	room := Room createWithSize: 50@100 withName: 'test' withColor: Color black.
	device := Camera new.
	device attachTo: room.
	
	self assert: (room hasDevice: device).
	self assert: (device isAttachedTo: room).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 19:20'!
testCreateCameraSensor
	| camera |
	camera := Camera createWithName: 'Camera 01'.
	self assert: (camera name = 'Camera 01').
	self assert: (camera size = (30@30)).
	self assert: (camera color = Color black).
	self assert: (camera height = 30).
	self assert: (camera width = 30).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:16'!
testCreateRoom
	| room |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	self assert: (room name = 'Kitchen').
	self assert: (room width = 50).
	self assert: (room height = 100).
	self assert: (room center = (25@50)).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 15:22'!
testCreateUser
	| user |
	user := User createWithName: 'simon'.
	self assert: (user name = 'simon').
	self assert: (user color = Color blue).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:27'!
testObserverDoesNotGetNotfiedOfUserEntry
	| room device user mockObserver |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	device := DummyDevice new.
	device attachTo: room.
	mockObserver := MockObserver new.
	mockObserver observe: device.
	user := User createWithName: 'Tom'.
	room addUser: user.
	self deny: (mockObserver detectedUser: user).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:51'!
testObserverDoesNotGetNotfiedOfUserExitAfterStopsObserving
	| room device user mockObserver |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	device := Camera new.
	device attachTo: room.
	mockObserver := MockObserver new.
	mockObserver observe: device.
	user := User createWithName: 'Tom'.
	room addUser: user.
	mockObserver stopObserving: device.
	room removeUser: user.
	self assert: (mockObserver detectedUser: user).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:26'!
testObserverGetsNotfiedOfUserEntry
	| room device user mockObserver |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	device := Camera new.
	device attachTo: room.
	mockObserver := MockObserver new.
	mockObserver observe: device.
	user := User createWithName: 'Tom'.
	room addUser: user.
	self assert: (mockObserver detectedUser: user).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:29'!
testObserverGetsNotfiedOfUserExit
	| room device user mockObserver |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	device := Camera new.
	device attachTo: room.
	mockObserver := MockObserver new.
	mockObserver observe: device.
	user := User createWithName: 'Tom'.
	room addUser: user.
	self assert: (mockObserver detectedUser: user).
	room removeUser: user.
	self deny: (mockObserver detectedUser: user).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 20:01'!
testUserEntersRoom
	| room user |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	user := User createWithName: 'Tom'.
	room addUser: user.
	self assert: (room includesUser: user).! !

Object subclass: #HomeAutomationDevice
	instanceVariableNames: 'handledEvents room'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

HomeAutomationDevice subclass: #DummyDevice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!HomeAutomationDevice methodsFor: 'associating' stamp: 'CameronRieck 3/7/2013 14:08'!
attachTo: aRoom
	room := aRoom.
	aRoom addDevice: self.
	handledEvents
		associationsDo: [ :assoc | 
			| event message value |
			event := assoc key.
			message := assoc value key.
			value := assoc value value.
			aRoom when: event send: message to: self with: value ]! !

!HomeAutomationDevice methodsFor: 'events' stamp: 'CameronRieck 3/7/2013 13:36'!
handleEvent: anEvent with: messageParamAssoc
	handledEvents at: anEvent put: messageParamAssoc.! !

!HomeAutomationDevice methodsFor: 'events' stamp: 'CameronRieck 3/7/2013 13:38'!
handlesEvent: anEvent
	^ handledEvents includes: anEvent! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 13:47'!
initialize
	super initialize.
	handledEvents := Dictionary new.
	room := nil.! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 13:46'!
isAttachedTo: aRoom 
	^ aRoom hasDevice: self! !

!HomeAutomationDevice methodsFor: 'associating' stamp: 'CameronRieck 3/7/2013 13:46'!
isAttachedToARoom
	^ room notNil! !

!HomeAutomationDevice methodsFor: 'events' stamp: 'CameronRieck 3/7/2013 15:00'!
listenTo: aDevice forEvent: anEvent
	self halt.
	(self handlesEvent: anEvent)
		ifTrue: [ 
			| message param |
			message := self messageForEvent: anEvent.
			param := self paramForEvent: anEvent.
			aDevice
				when: anEvent
				send: message
				to: self
				with: param ]! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:10'!
userEntersMessage
	^ (Association new) key: #userEnters: value: #aUser.
	! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:32'!
userExitsMessage
	^ (Association new) key: #userExits: value: #aUser.
	! !

HomeAutomationDevice subclass: #HomeAutomationObserver
	instanceVariableNames: 'usersTracked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!HomeAutomationObserver methodsFor: 'accessing' stamp: 'CameronRieck 3/7/2013 13:26'!
detectedUser: aUser 
	^ usersTracked includes: aUser.	
! !

!HomeAutomationObserver methodsFor: 'accessing' stamp: 'CameronRieck 3/7/2013 13:26'!
initialize
	super initialize.
	usersTracked := Set new.
! !

!HomeAutomationObserver methodsFor: 'associating' stamp: 'CameronRieck 3/7/2013 15:01'!
observe: aDevice
	aDevice when: #userEnters send: #userEnters: to: self with: #aUser.
	aDevice when: #userExits send: #userExits: to: self with: #aUser.! !

!HomeAutomationObserver methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:55'!
stopObserving: aDevice
	aDevice removeActionsWithReceiver: self. 
	! !

!HomeAutomationObserver methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:13'!
userEnters: aUser
	usersTracked add: aUser.! !

!HomeAutomationObserver methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:34'!
userExits: aUser
	usersTracked remove: aUser.! !

HomeAutomationObserver subclass: #MockObserver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

HomeAutomationDevice subclass: #HomeAutomationSensor
	instanceVariableNames: 'name size color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

HomeAutomationSensor subclass: #Camera
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!Camera class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:02'!
createWithName: aName
	| newCamera |
	newCamera := Camera new.
	newCamera name: aName.
	^ newCamera.! !

!Camera methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:32'!
initialize
	super initialize.
	self size: 30@30.
	self color: Color black.
	self handleEvent: #userEnters with: (self userEntersMessage).
	self handleEvent: #userExits with: (self userExitsMessage).! !

!Camera methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:33'!
userEnters: aUser
	self triggerEvent: #userEnters with: aUser.! !

!Camera methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:33'!
userExits: aUser
	self triggerEvent: #userExits with: aUser.! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:59'!
color
	^ color! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:59'!
color: aColor
	color := aColor.! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 13:02'!
height
	^ size y! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:01'!
initialize
	super initialize.
	name := ''.
	size := 0@0.
	color := Color white.! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 2/28/2013 20:26'!
name 
	^ name! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 2/28/2013 20:25'!
name: aByteString 
	name := aByteString.! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:59'!
size
	^ size! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:59'!
size: aSize
	size := aSize.! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 13:02'!
width
	^ size x! !

Object subclass: #Room
	instanceVariableNames: 'roomSize attachedDevices color name usersPresent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!Room class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/2/2013 15:48'!
createWithSize: aPoint 
	| room |
	room := Room new.
	room setSize: aPoint.
	^ room.! !

!Room class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 11:53'!
createWithSize: aPoint withName: aName
	| room |
	room := Room new.
	room setSize: aPoint.
	room setName: aName.
	^ room.! !

!Room class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:07'!
createWithSize: aPoint withName: aName withColor: aColor
	| room |
	room := Room new.
	room setSize: aPoint.
	room setName: aName.
	room setColor: aColor.
	^ room.! !

!Room methodsFor: 'associating' stamp: 'CameronRieck 3/2/2013 15:41'!
addDevice: aDevice
	attachedDevices add: aDevice.! !

!Room methodsFor: 'updating' stamp: 'CameronRieck 3/7/2013 14:31'!
addUser: aUser 
	usersPresent add: aUser.
	self triggerEvent: #userEnters with: aUser.! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 18:51'!
attachedDevices
	^ attachedDevices! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:16'!
center
	^ ((self width) / 2)@((self height) / 2)! !

!Room methodsFor: 'associating' stamp: 'CameronRieck 3/3/2013 12:07'!
color
	^ color! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 18:51'!
devices
	^ attachedDevices! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 11:48'!
hasDevice: aDevice
	^ attachedDevices includes: aDevice! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/3/2013 12:14'!
height
	^ roomSize y! !

!Room methodsFor: 'accessing' stamp: 'CameronRieck 3/6/2013 20:02'!
includesUser: aUser 
	^ usersPresent includes: aUser.! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 20:01'!
initialize
	attachedDevices := OrderedCollection new.
	usersPresent := Set new.! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/3/2013 11:58'!
length
	^ roomSize y! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/3/2013 11:54'!
name
	^ name! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:37'!
removeUser: aUser
	self triggerEvent: #userExits with: aUser.
	usersPresent remove: aUser.
	! !

!Room methodsFor: 'associating' stamp: 'CameronRieck 3/3/2013 12:07'!
setColor: aColor
	color := aColor.! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/3/2013 11:54'!
setName: aName
	name := aName.! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/2/2013 15:35'!
setSize: aPoint 
	roomSize := aPoint.! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/3/2013 11:58'!
width
	^ roomSize x! !

Object subclass: #User
	instanceVariableNames: 'name color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!User class methodsFor: 'instance creation' stamp: 'CameronRieck 3/7/2013 15:20'!
createWithName: aName 
	| newUser |
	newUser := User new.
	newUser name: aName.
	newUser color: User defaultColor.
	^ newUser.! !

!User class methodsFor: 'instance creation' stamp: 'CameronRieck 3/7/2013 15:20'!
createWithName: aName andColor: aColor
	| newUser |
	newUser := User new.
	newUser name: aName.
	newUser color: aColor.
	^ newUser.! !

!User class methodsFor: 'instance creation' stamp: 'CameronRieck 3/7/2013 15:20'!
defaultColor
	^ Color blue! !

!User methodsFor: 'accessing' stamp: 'CameronRieck 3/7/2013 15:19'!
color
	^ color! !

!User methodsFor: 'accessing' stamp: 'CameronRieck 3/7/2013 15:19'!
color: aColor
	color := aColor! !

!User methodsFor: 'accessing' stamp: 'CameronRieck 3/7/2013 15:19'!
name
	^ name! !

!User methodsFor: 'accessing' stamp: 'CameronRieck 3/6/2013 20:00'!
name: aName 
	name := aName.! !
